<!--//
////////////////////////////////////////////////////////////////////////////////
//
//  Copyright © 2009-2012 Nick Connors
//	gpumonitor@gmail.com
//
////////////////////////////////////////////////////////////////////////////////
//-->
var version = "1.1";
var fso  = new ActiveXObject("Scripting.FileSystemObject");
var prefIndex;
var haBarColor;
var prefWindow;
var prefMonitors = [];
var rtMonitors = [];
var icons = [
				["Temperature Black", "icons/temp-b.png", "sideshowicons/temp-b.gif"],
				["Temperature Light", "icons/temp-l.png", "sideshowicons/temp-l.gif"],
				["Fan Black", "icons/fan-b.png", "sideshowicons/fan-b.gif"],
				["Fan Light", "icons/fan-l.png", "sideshowicons/fan-l.gif"],
				["Chip Black", "icons/chip-b.png", "sideshowicons/chip-b.gif"],
				["Chip Light", "icons/chip-l.png", "sideshowicons/chip-l.gif"],
				["Voltage Black", "icons/voltage-b.png", "sideshowicons/voltage-b.gif"],
				["Voltage Light", "icons/voltage-l.png", "sideshowicons/voltage-l.gif"],
				["Hard Drive Black", "icons/hdd-b.png", "sideshowicons/hdd-b.gif"],
				["Hard Drive Light", "icons/hdd-l.png", "sideshowicons/hdd-l.gif"],
				["Network Black", "icons/network-b.png", "sideshowicons/network-b.gif"],
				["Network Light", "icons/network-l.png", "sideshowicons/network-l.gif"],
				["LCD Clear", "icons/lcd.png", "sideshowicons/lcd.gif"],
				["Intel Black", "icons/intel-b.png", "sideshowicons/intel-b.gif"],
				["Intel Light", "icons/intel-l.png", "sideshowicons/intel-l.gif"],
				["AMD Black", "icons/amd-b.png", "sideshowicons/amd-b.gif"],
				["AMD Light", "icons/amd-l.png", "sideshowicons/amd-l.gif"],
				["ATI Radeon", "icons/radeon.png", "sideshowicons/radeon.gif"],
				["ATI CrossFire", "icons/crossfire.png", "sideshowicons/crossfire.gif"],
				["NVIDIA GeForce", "icons/geforce.png", "sideshowicons/geforce.gif"],
				["NVIDIA SLI", "icons/sli.png", "sideshowicons/sli.gif"],
				["Windows Black", "icons/windows-b.png", "sideshowicons/windows-b.gif"],
				["Windows Light", "icons/windows-l.png", "sideshowicons/windows-l.gif"],
				["Windows Color", "icons/windows-c.png", "sideshowicons/windows-c.gif"],
				["Lightning Black", "icons/lightning-b.png", "sideshowicons/lightning-b.gif"],
				["Lightning Light", "icons/lightning-l.png", "sideshowicons/lightning-l.gif"],
				["Clock Black", "icons/clock-b.png", "sideshowicons/clock-b.gif"],
				["Clock Light", "icons/clock-l.png", "sideshowicons/clock-l.gif"],
				["Battery Black", "icons/battery-b.png", "sideshowicons/battery-b.gif"],
				["Battery Light", "icons/battery-l.png", "sideshowicons/battery-l.gif"],
				["LCD Black", "icons/lcd-b.png", "sideshowicons/lcd-b.gif"],
				["LCD Light", "icons/lcd-l.png", "sideshowicons/lcd-l.gif"],
				["MSI Afterburner", "icons/afterburner.png", "sideshowicons/afterburner.gif"],
				["HWiNFO", "icons/HWiNFO.png", "sideshowicons/HWiNFO.gif"]
				];
var barWidths, divHeight;
var barWidthsLg = [0,158,252,0,176,266,192,292,112,212,292,192,122,0,291,291,292,0,0];
var divHeightLg = [26,38,38,38,24,24,24,24,24,24,22,22,22,22,65,55,35,24,38];
var barWidthsSm = [0,48,96,0,60,108,74,122,48,96,122,74,48,0,121,121,122,0,0];
var divHeightSm = [13,24,24,22,12,12,12,12,12,12,10,10,10,10,43,33,23,12,24];	
var barStyles = [1,2,4,5,6,7,8,9,10,11,12,16];
var graphStyles = [14,15];
var minMaxStyles = [3,18];
var previousReadWriteCollision = 0;
var userTempDir;
var userDataDir;
var appDir;
var debug;
var debugFile;
var sideshowEnabled;
var upgradeVersion = false;
var STR_PAD_LEFT = 1;
var STR_PAD_RIGHT = 2;
var STR_PAD_BOTH = 3;

function DefaultWindow()
{
	this.version = version;
	this.bgColor = "#000000";
	this.borderColor = "#444444";
	this.titleColor = "#FFFFFF";
	this.titleEnabled = true;
	this.hasTitleBorder = true;
	this.titleBorderColor = "888888"
	this.titleIcon = 33;
	this.dspTitle = "HWiNFO<br/>Sensor Status";
	this.defaultMonitorTitleColor = "#87CEFA";
	this.defaultMonitorValueColor = "#FFFFFF";
	this.defaultMonitorUnitsColor = "#87CEFA";
	this.defaultMonitorGridColor = "#004400";
	this.defaultMonitorHdrBkgdColor = "#444444";
	this.defaultMonitorHdrTextColor = "#FFFFFF";
	this.defaultGraphLineStyle = 0;
	this.refreshInterval = 3;
	this.temperatureScale = 0;
	this.height = 200;
	this.SSEnabled = false;
	this.SSStyle = 0;
}

function DefaultMonitor()
{
	this.id = "";
	this.sensor = "";
	this.title = "";
	this.dspTitle = "";
	this.value = 0;
	this.units = "";
	this.minval = 9999;
	this.maxval = 0;
	this.style = 0;
	this.useDefaultColors = true;
	this.titleColor = "#87CEFA";
	this.valueColor = "#FFFFFF";
	this.unitsColor = "#87CEFA";
	this.gridColor = "#004400";
	this.hdrBkgdColor = "#444444";
	this.hdrTextColor = "#FFFFFF";
	this.iconIndex = 0;
	this.barLimit = [0,70,80,90,100];
	this.barColors = ["#36B74E", "#FFFF00", "#FF6600", "#FF0000"];
	this.enabled = true;
	this.hasSeparator = false;
	this.path = [];
	this.SSEnabled = false;
	this.hasHeader = false;
	this.header = "";
	this.modType = 0;
	this.modFactor = 0;
	this.modUnits = "";
	this.modValue = 0;
}

function getEnvVariables()
{
	try{
		var wshell = new ActiveXObject("WScript.Shell");
		userTempDir = wshell.ExpandEnvironmentStrings("%TEMP%");
		dataFilePath = userTempDir + "\\HWiNFOMonitor.log";
		userDataDir = wshell.ExpandEnvironmentStrings("%LOCALAPPDATA%") + "\\HWiNFOMonitor";
		if(userDataDir.indexOf("%LOCALAPPDATA%") > -1){
			userDataDir = wshell.ExpandEnvironmentStrings("%APPDATA%") + "\\HWiNFOMonitor";
		}
		appDir = System.Gadget.path;
	}catch(ex){
		displayError("Error reading environment variables", ex);
	}
}

function parseRTMonitors() {
	var tmpFile = userTempDir + "\\HWiNFOMonitor.log";
	if(fso.FileExists(tmpFile))
	{
		try
    	{
        	var stream = fso.OpenTextFile(tmpFile,1);
			var hwinfoData = stream.ReadAll();
			stream.Close();
			rtMonitors = jsonParse(hwinfoData);
			return true;
    	}catch(ex){
			if(previousReadWriteCollision >= 5){
				displayError("Could not read HWiNFO Monitor data");
			}else{
				previousReadWriteCollision++;
				if(debug && previousReadWriteCollision>1)writeDebug("Error reading HWiNFO values - incrementing collision value to " + previousReadWriteCollision);				
			}
			return false;
		}
	}else{
		displayError("HWiNFO Hardware Monitor data not found.");
		return false;
	}
	return false;
}

function trimValue(value, units)
{
	if(!value || value===undefined){
		return 0;
	}
	units = units.toLowerCase();	
	value = numInRange(value, 0, 9999, value);
	if(units == "v" || units == "a" || units == "hrs"){
		return value.toFixed(2);
	}else if(units == "fps" || units == "x" || units == "w"){
		return value.toFixed(1);
	}else{
		return Math.round(value);
	}
}

function loadPreviousPrefs()
{
	var f;
	var tmpFile = userDataDir + "\\prefWindow_" + prefIndex + ".json";
	if(fso.FileExists(tmpFile)){
		if(debug)writeDebug("prefWindow_" + prefIndex + ".json exists - exiting loadPreviousPrefs");
		return;
	}
	
	tmpFile = userDataDir + "\\prefWindow.json";
	if(fso.FileExists(tmpFile))
	{
		try{
			if(debug)writeDebug("prefWindow.json exists - copying to: prefWindow_" + prefIndex + ".json");
			f = fso.GetFile(tmpFile);
			f.Copy(userDataDir + "\\prefWindow_" + prefIndex + ".json");
    	}catch(ex){
			if(debug)writeDebug("Error copying prefWindow.json to prefWindow_" + prefIndex + ".json", ex);
		}
	}
	
	tmpFile = userDataDir + "\\prefMonitors.json";
	if(fso.FileExists(tmpFile))
	{
		try{
			if(debug)writeDebug("prefMonitors.json exists - copying to: prefMonitors_" + prefIndex + ".json");
			f = fso.GetFile(tmpFile);
			f.Copy(userDataDir + "\\prefMonitors_" + prefIndex + ".json");
    	}catch(ex){
			if(debug)writeDebug("Error copying prefMonitors.json to prefMonitors" + prefIndex + ".json", ex);
		}
	}
}

function savePrefWindow()
{
	if(debug)writeDebug("Saving window preferences: " + prefIndex);
	try{
		var tmpFile=fso.CreateTextFile(userDataDir + "\\prefWindow_" + prefIndex + ".json", true);
		tmpFile.Write(JSON.stringify(prefWindow));
		tmpFile.Close();
		return true;
	}catch (ex){
		if(debug)writeDebug("Error writing prefWindow json to file", ex);
		displayError("Error writing general preferences to file", ex);
		return false;
	}
}

function savePrefMonitors()
{
	if(debug)writeDebug("Saving monitor preferences: " + prefIndex);
	try{
		var tmpFile=fso.CreateTextFile(userDataDir + "\\prefMonitors_" + prefIndex + ".json", true);
		tmpFile.Write(JSON.stringify(prefMonitors));
		tmpFile.Close();
		return true;
	}catch(ex){
		if(debug)writeDebug("Error writing prefMonitors json to file", ex);
		displayError("Error writing monitor preferences to file", ex);
		return false
	}
}

function upgradeMonitors() {
	if(debug)writeDebug("Upgrading monitor preferences");
	/*for (var i = 0; i < prefMonitors.length; i++){

	}*/
	upgradeVersion = false;
}

function upgradeSettings(){
	if(debug)writeDebug("Upgrading window preferences");
}

function getPrefIndex()
{
	try{
		if(!System.Gadget.Settings.readString("prefIndex")) {
			if(debug)writeDebug("prefIndex not found - attempting to load previous preferences");
			prefIndex = 0;
			loadPreviousPrefs();
		}else{
			prefIndex = System.Gadget.Settings.readString("prefIndex");
			if(debug)writeDebug("prefIndex=" + prefIndex);
		}
	}catch(ex){
		if(debug)writeDebug("Error getting prefIndex - setting value to 0", ex);
		prefIndex = 0;
	}
}

function calculateBarColor(monitor)
{
	if(monitor.modValue >= monitor.barLimit[3]) {
		return monitor.barColors[3];
	} else if(monitor.modValue >= monitor.barLimit[2]) {
		return monitor.barColors[2];
	} else if(monitor.modValue >= monitor.barLimit[1]) {
		return monitor.barColors[1];
	} else {
		return monitor.barColors[0];
	}
}

function calculateBarWidth(monitor, width)
{
	var barPercent;
	
	if (monitor.modValue <= monitor.barLimit[0]) {
		barPercent = 0;
	} else if (monitor.modValue >= monitor.barLimit[4]) {
		barPercent = 100;
	} else {
		barPercent = (monitor.modValue - monitor.barLimit[0]) / (monitor.barLimit[4] - monitor.barLimit[0]) * 100;
	}
	return parseInt(barPercent / 100 * width);
}

function getUnits(monitor){
	if(monitor.modType > 0){
		if(monitor.modUnits == ""){
			return Left(monitor.units, 4);
		}else{
			return Left(monitor.modUnits, 4);
		}
	}else{		
		return Left(monitor.units, 4);
	}	
}

function translateValue(monitor){
	switch (monitor.modType)
	{
		case 1: {
			monitor.modValue = monitor.value * parseFloat(monitor.modFactor);
			break;
		}
		case 2: {
			if(monitor.modFactor > 0){monitor.modValue = monitor.value / parseFloat(monitor.modFactor);}
			break;
		}
		case 3: {
			if(monitor.value > 0){monitor.modValue = parseFloat(monitor.modFactor) / monitor.value;}
			break;
		}
		case 4: {
			monitor.modValue = monitor.value + parseFloat(monitor.modFactor);
			break;
		}
		case 5: {
			monitor.modValue = monitor.value - parseFloat(monitor.modFactor);
			break;
		}
		case 6: {
			monitor.modValue = parseFloat(monitor.modFactor) - monitor.value;
			break;
		}
		default: {
			monitor.modValue = monitor.value;
			break;
		}
	}
}

function updateMonitor(monitor, container, id)
{
	if(document.getElementById(monitor.id + "tooltip")){
		document.getElementById(monitor.id + "tooltip").title = monitor.title + "\n Current:\t\t"+ monitor.value + "\n Minimum:\t"+ monitor.minval + "\n Maximum:\t" + monitor.maxval;
	}
		
	if(getArrayIndex(graphStyles,monitor.style) > -1){
		monitor.path.shift();
		monitor.path.push(100 - calculateBarWidth(monitor, 100));
		if(document.getElementById(monitor.id + "path")){
			updateGraphPath(monitor);
		}
	}
	
	if(getArrayIndex(barStyles,monitor.style) > -1){
		if(document.getElementById(monitor.id + "barBack")){
			document.getElementById(monitor.id + "barBack").style.width = calculateBarWidth(monitor, barWidths[monitor.style]);
			document.getElementById(monitor.id + "barBack").style.backgroundColor = calculateBarColor(monitor);
		}
		if(document.getElementById(monitor.id + "barImg")){
			document.getElementById(monitor.id + "barImg").style.width = calculateBarWidth(monitor, barWidths[monitor.style]);
		}	
	}
	
	if(getArrayIndex(minMaxStyles,monitor.style) > -1){
		document.getElementById(monitor.id + "minval").innerHTML = trimValue(monitor.minval, getUnits(monitor));
		document.getElementById(monitor.id + "maxval").innerHTML = trimValue(monitor.maxval, getUnits(monitor));
	}
	
	if(document.getElementById(monitor.id + "value")){
		document.getElementById(monitor.id + "value").innerHTML = trimValue(monitor.modValue, getUnits(monitor));
	}		
		
	if(sideshowEnabled && monitor.SSEnabled)writeSideShowMonitor(monitor, id);
}

function drawMonitor(monitor, container, id)
{
	var colorTitle;
	var colorValue;
	var colorUnits;
	var colorGrid;
	var colorHdrBkgd;
	var colorHdrText;
	
	var dhtml = "";
	var barWidth = calculateBarWidth(monitor, barWidths[monitor.style]);	
	var dspUnits = getUnits(monitor);
	var dspValue = trimValue(monitor.modValue, dspUnits);
	
	if(monitor.useDefaultColors){
		colorTitle = prefWindow.defaultMonitorTitleColor;
		colorValue = prefWindow.defaultMonitorValueColor;
		colorUnits = prefWindow.defaultMonitorUnitsColor;
		colorGrid = prefWindow.defaultMonitorGridColor;
		colorHdrBkgd = prefWindow.defaultMonitorHdrBkgdColor;
		colorHdrText = prefWindow.defaultMonitorHdrTextColor;
	}else{
		colorTitle = monitor.titleColor;
		colorValue = monitor.valueColor;
		colorUnits = monitor.unitsColor;
		colorGrid = monitor.gridColor;
		colorHdrBkgd = monitor.hdrBkgdColor;
		colorHdrText = monitor.hdrTextColor;
	}
	
	if(monitor.hasHeader){
		dhtml += '<div class="mHeader" style="background-color:' + colorHdrBkgd + ';color:' + colorHdrText + ';border-color:' + colorHdrText + ';';
		if(colorHdrBkgd == "transparent"){
			dhtml += 'background-image:none;';
		}
		dhtml += '">' + monitor.header + '</div>';
		if(System.Gadget.docked){
			prefWindow.height = prefWindow.height + 16;
		}else{
			prefWindow.height = prefWindow.height + 30;
		}
		
	}	
	dhtml += '<div id="' + monitor.id + 'tooltip" title="' + monitor.title + "&#13; Current:&#9;&#9;"+ dspValue + "&#13; Minimum:&#9;"+ monitor.minval + "&#13; Maximum:&#9;" + monitor.maxval + '" style="height:' + divHeight[monitor.style] + 'px;overflow:hidden;margin:1px 0;">';
	
	//monitor.style=9; //Math.floor(Math.random()*19);
	switch (monitor.style)
	{
		case 1: { //Large Image/Bar
			dhtml += '<div class="mImageLg"><img class="lgIcon" src="' + icons[monitor.iconIndex][1] + '" /></div>';
			dhtml += '<div class="mTitle mTitle96 top-1" style="color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="mBar top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div></div>';
			dhtml += '<div class="mUnits" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValue" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</div>';			
			break;
			}
		case 2: { //Large Image/Bar Overlayed
			dhtml += '<div class="mImageLg"><img class="lgIcon" src="' + icons[monitor.iconIndex][1] + '" /></div>';
			dhtml += '<div class="mTitle mTitle96 top-1" style="color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';			
			dhtml += '<div class="mBar top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div>';
			dhtml += '<div class="overlay"><span class="mValue" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</span>';
			dhtml += '<span class="mUnits" style="color:' + colorUnits + ';">' + dspUnits + '</span></div>';
			dhtml += '</div>';
			break;
			}
		case 3: { //Large No Bar
			dhtml += '<div class="minmax top-1" id="' + monitor.id + 'minval" style="color:' + colorUnits + ';">' + trimValue(monitor.minval, dspUnits) + '</div>';
			dhtml += '<div class="mTitle mTitle100 top-1" style="float:right;text-align:right;color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="minmax" id="' + monitor.id + 'maxval" style="color:' + colorUnits + ';">' + trimValue(monitor.maxval, dspUnits) + '</div>';
			dhtml += '<div class="mTitle mTitle100" style="float:right;text-align:right;color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValueLg" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</div>';
			break;
			}
		case 4: { //Med Image/Bar
			dhtml += '<div class="mImageSm"><img class="smIcon" src="' + icons[monitor.iconIndex][1] + '" /></div>';			
			dhtml += '<div class="mBar top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<div class="overlay"><div class="mTitle" style="padding:0 1px 0 2px;color:' + colorTitle + ';">' + monitor.dspTitle + '</div></div>';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div></div>';
			dhtml += '<div class="mUnits" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValue" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</div>';	
			break;
			}
		case 5: { //Med Image/Bar Overlayed			
			dhtml += '<div class="mImageSm"><img class="smIcon" src="' + icons[monitor.iconIndex][1] + '" /></div>';			
			dhtml += '<div class="mBar top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div>';		
			dhtml += '<div class="overlay"><span class="mValue" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</span>';
			dhtml += '<span class="mUnits" style="color:' + colorUnits + ';">' + dspUnits + '</span></div>';
			dhtml += '</div>';
			break;
			}
		case 6: { //Med Bar
			dhtml += '<div class="mBar top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<div class="overlay"><div class="mTitle" style="padding:0 1px 0 2px;color:' + colorTitle + ';">' + monitor.dspTitle + '</div></div>';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div></div>';			
			dhtml += '<div class="mUnits" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValue" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</div>';			
			break;
			}
		case 7: { //Med Bar Overlayed
			dhtml += '<div class="mBar top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div>';
			dhtml += '<div class="overlay"><div class="mTitle" style="padding:0 2px;color:' + colorTitle + ';width:74px;">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="mUnits" style="float:right;padding:0 1px;color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValue" id="' + monitor.id + 'value" style="float:right;padding:0 1px;color:' + colorValue + ';">' + dspValue + '</div>';
			dhtml += '</div></div>';
			break;
			}
		case 8: { //Med Title/Bar
			dhtml += '<div class="mTitle mTitle26" style="color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="mBar top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div></div>';
			dhtml += '<div class="mUnits" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValue" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</div>';	
			break;
			}
		case 9: { //Med Title/Bar Overlayed
			dhtml += '<div class="mTitle mTitle26" style="color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="mBar top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div>';
			dhtml += '<div class="overlay"><span class="mValue" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</span>';
			dhtml += '<span class="mUnits" style="color:' + colorUnits + ';">' + dspUnits + '</span></div>';
			dhtml += '</div>';
			break;
			}
		case 10: { //Sm Bar Only
			dhtml += '<div class="mBarMini top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div></div>';			
			break;
			}
		case 11: { //Sm Bar
			dhtml += '<div class="mBarMini top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div></div>';			
			dhtml += '<div class="mUnitsMini top-1" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValueMini top-1" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</div>';			
			break;
			}
		case 12: { //Sm Title/Bar
			dhtml += '<div class="mTitleMini mTitle26 top-1" style="color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="mBarMini top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div></div>';			
			dhtml += '<div class="mUnitsMini top-1" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValueMini top-1" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</div>';			
			break;
			}
		case 13: { //Sm Text Only
			dhtml += '<div class="mTitleMini mTitle74 top-1" style="color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="mUnitsMini top-1" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValueMini top-1" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</div>';	
			break;
			}
		case 14: { //Graph w/Title
			dhtml += '<div class="mTitle mTitle74 top-1" style="color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="mUnits top-1" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValue top-1" id="' + monitor.id + 'value" style="margin-top:-1px;color:' + colorValue + ';">' + dspValue + '</div>';				
			dhtml += '<vml:group style="width:' + barWidths[monitor.style] + '; height:40;" coordorigin="0,0" coordsize="100,100" id="' + monitor.id + 'graphGroup">';
			dhtml += '<vml:rect style="width:100; height:100; top:0; left:0;" filled="false" strokecolor="' + colorGrid + '" />';				
			dhtml += '<vml:rect style="width:80; height:100; top:0; left:10;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:rect style="width:60; height:100; top:0; left:20;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:rect style="width:40; height:100; top:0; left:30;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:rect style="width:20; height:100; top:0; left:40;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:line from="50,0" to="50,100" strokecolor="' + colorGrid + '"></vml:line>';
			dhtml += '<vml:rect style="width:100; height:60; top:20; left:0;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:rect style="width:100; height:20; top:40; left:0;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:shape id="' + monitor.id + 'shape" style="width:100;height:100;" ' + getGraphType() + ' strokecolor="#00FF00" >';
			dhtml += '<vml:path id="' + monitor.id + 'path" style="width:100;height:100;" v="" />';
			dhtml += '</vml:shape>';
			dhtml += '</vml:group>';				
			dhtml += '<div style="margin-top=-32px;margin-left:2px;">';
			dhtml += '<div class="mTitle" style="margin-top=-12px;float:left;color:' + colorValue + ';">' + trimValue(monitor.barLimit[4], dspUnits) + '</div>';
			dhtml += '</div>';
			dhtml += '<div style="margin-top=10px;margin-left:2px;">';
			dhtml += '<div class="mTitle" style="float:left;color:' + colorValue + ';margin-top:4px;">' + trimValue(monitor.barLimit[0], dspUnits) + '</div>';
			dhtml += '<div>&nbsp;</div>';
			dhtml += '</div>';
			break;
			}
		case 15: { //Graph Overlayed
			dhtml += '<vml:group style="width:' + barWidths[monitor.style] + '; height:50;margin-top:1px;" coordorigin="0,0" coordsize="100,100" id="' + monitor.id + 'graphGroup">';
			dhtml += '<vml:rect style="width:100; height:100; top:0; left:0;" filled="false" strokecolor="' + colorGrid + '" />';				
			dhtml += '<vml:rect style="width:80; height:100; top:0; left:10;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:rect style="width:60; height:100; top:0; left:20;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:rect style="width:40; height:100; top:0; left:30;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:rect style="width:20; height:100; top:0; left:40;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:line from="50,0" to="50,100" strokecolor="' + colorGrid + '"></vml:line>';
			dhtml += '<vml:rect style="width:100; height:60; top:20; left:0;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:rect style="width:100; height:20; top:40; left:0;" filled="false" strokecolor="' + colorGrid + '" />';
			dhtml += '<vml:shape id="' + monitor.id + 'shape" style="width:100;height:100;" ' + getGraphType() + ' strokecolor="#00FF00" >';
			dhtml += '<vml:path id="' + monitor.id + 'path" v="" />';
			dhtml += '</vml:shape>';
			dhtml += '</vml:group>';
			dhtml += '<div class="mTitle mTitle120" style="margin-top=-52px;margin-left:2px;color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';				
			dhtml += '<div class="mValue" id="' + monitor.id + 'value" style="float:left;margin-top=-20px;margin-left:2px;color:' + colorValue + ';">' + dspValue + '</div>';
			dhtml += '<div class="mUnits" style="float:left;margin-top=-20px;margin-left:2px;color:' + colorUnits + ';">' + dspUnits + '</div>';
			break;
			}
		case 16: { //Lg Text/Bar Only
			dhtml += '<div class="mTitle mTitle74 top-1" style="color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="mUnits top-1" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValue" id="' + monitor.id + 'value" style="margin-top:-1px;color:' + colorValue + ';">' + dspValue + '</div>';	
			dhtml += '<div class="mBar top1" style="width:' + barWidths[monitor.style] + ';">';
			dhtml += '<img style="position:absolute;width:' + barWidths[monitor.style] + ';" src="images/barbackground.png" />';
			dhtml += '<div class="mbarColor" id="' + monitor.id + 'barBack" style="background-color:' + calculateBarColor(monitor) + ';width:' + barWidth + ';">';
			dhtml += '<img src="images/barbackgroundcolor.png" id="' + monitor.id + 'barImg" style="width:' + barWidth + 'px;"/></div></div>';		
			break;
			}
		case 17: { //Med Image/Text
			dhtml += '<div class="mImageSm"><img class="smIcon" src="' + icons[monitor.iconIndex][1] + '" /></div>';			
			dhtml += '<div class="mTitle mTitle60 top-1" style="color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="mUnits top-1" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValue" id="' + monitor.id + 'value" style="margin-top:-1px;color:' + colorValue + ';">' + dspValue + '</div>';			
			break;
			}
		case 18: { //Large Image w/Min&Max
			dhtml += '<div class="mImageLg"><img class="lgIcon" src="' + icons[monitor.iconIndex][1] + '" /></div>';
			dhtml += '<div class="mTitle mTitle96" style="color:' + colorTitle + ';">' + monitor.dspTitle + ' (' + dspUnits + ')</div>';
			dhtml += '<div class="mTitle">';
			dhtml += '<div class="mValue2" id="' + monitor.id + 'minval" style="float:left;color:' + colorTitle + ';">' + trimValue(monitor.minval, dspUnits) + '</div>';				
			dhtml += '<div class="mValue2" id="' + monitor.id + 'maxval" style="float:right;color:' + colorTitle + ';">' + trimValue(monitor.maxval, dspUnits) + '</div>';
			dhtml += '<div class="mValue2" id="' + monitor.id + 'value" style="font-weight:bold;color:' + colorValue + ';">' + dspValue + '</div>';
			dhtml += '</div>';
			break;
			}
		default: { //Med Text Only
			dhtml += '<div class="mTitle mTitle74 top-1" style="color:' + colorTitle + ';">' + monitor.dspTitle + '</div>';
			dhtml += '<div class="mUnits" style="color:' + colorUnits + ';">' + dspUnits + '</div>';
			dhtml += '<div class="mValue top-1" id="' + monitor.id + 'value" style="color:' + colorValue + ';">' + dspValue + '</div>';	
			break;
			}
	}

	dhtml += '</div><div style="clear:both;"></div>';
	if(monitor.hasSeparator){
		dhtml += '<div style="margin:-3px 0;"><hr style="height:1px;color:' + prefWindow.borderColor + '" /></div>';
		prefWindow.height = prefWindow.height + 9;
	}
	container.innerHTML = dhtml;
	container.style.height = divHeight[monitor.style] + "px";
	prefWindow.height += divHeight[monitor.style] + 2; //4;
	if(sideshowEnabled && monitor.SSEnabled)writeSideShowMonitor(monitor, id);
}

function getGraphType() {
	switch(prefWindow.defaultGraphLineStyle)
	{
		case 1: // thick line
			return 'strokeweight="2" filled="false"';
		case 2: // filled
			return 'strokeweight="1" filled="black"';
		default: // thin line
			return 'strokeweight="1" filled="false"';
	}
}

function updateGraphPath(monitor)
{
	var startPt;
	for(var i = 0; i < 100; i++){
		if(monitor.path[i] > -1){
			startPt = i;
			break;
		}
	}
	
	var newPath = "";
	if(prefWindow.defaultGraphLineStyle == 2)
		newPath = "M " + startPt + ",100";
	else	
		newPath = "M " + startPt + "," + monitor.path[startPt];
	
	for(var i = startPt; i < 100; i++){
		newPath += " L " + i + "," + monitor.path[i];
	}	
	if(prefWindow.defaultGraphLineStyle == 2) newPath += " L 100, 100";
	
	document.getElementById(monitor.id + "path").v = newPath + " E";
	
	var graphColor = calculateBarColor(monitor)
	document.getElementById(monitor.id + "shape").strokecolor = graphColor;
	if(prefWindow.defaultGraphLineStyle == 2) document.getElementById(monitor.id + "shape").fillcolor = graphColor;
}

function numInRange(value, minVal, maxVal, defVal)
{
	if(isNaN(value) || value == "")	return defVal;
	if(value<minVal) return minVal;
	if(value>maxVal) return maxVal;
	return value;
}

function toFahrenheit(celcius)
{
	return 9/5 * celcius + 32;
}

function toCelcius(fahrenheit)
{
	return 5/9 * (fahrenheit - 32);
}

function createDebugLog(msg)
{
	try{
		var logID = Math.floor(Math.random()*99);
		debugFile=fso.CreateTextFile(userDataDir + "\\debug_" + logID + ".log", true);
		debugFile.WriteLine(Date() + " - creating debug log: " + msg);
	}catch(ex){
		debug = false;
	}
}

function writeDebug(msg, ex)
{	
	var d = new Date();
	var dt = d.getMonth()+1 + "/" +  d.getDate() + "/" + d.getFullYear() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds() + "." + d.getMilliseconds();
	
	if(ex){
		debugFile.WriteLine(dt + d.getMilliseconds() + " - " + msg + " (" + ex.name + ": " + ex.number + " - " + ex.description + ")");
	}else{
		debugFile.WriteLine(dt + d.getMilliseconds() + " - " + msg);
	}
}

function getArrayIndex(a,v) {
	for (i=0; i<a.length; i++){
		if (a[i]==v) return i;
	}
	return -1;
}

String.prototype.replaceAll = function( 
	strTarget,
	strSubString
	){
	var strText = this;
	var intIndexOfMatch = strText.indexOf( strTarget );
	 
	while (intIndexOfMatch != -1){
		strText = strText.replace( strTarget, strSubString )
		intIndexOfMatch = strText.indexOf( strTarget );
	}
	return( strText );
}

Array.prototype.move_element = function(index, delta) {

  // This method moves an element within the array
  // index = the array item you want to move
  // delta = the direction and number of spaces to move the item.
  //
  // Example:
  // move_element(myarray, 5, -1); // move up one space
  // move_element(myarray, 2, 1); // move down one space
  //
  // Returns true for success, false for error.

  var index2, temp_item;

  // Make sure the index is within the array bounds
  if (index < 0 || index >= this.length) {
    return false;
  }

  // Make sure the target index is within the array bounds
  index2 = index + delta;
  if (index2 < 0 || index2 >= this.length || index2 == index) {
    return false;
  }

  // Move the elements in the array
  temp_item = this[index2];
  this[index2] = this[index];
  this[index] = temp_item;

  return true;
}

Array.prototype.clean = function(deleteValue) {
  for (var i = 0; i < this.length; i++) {
    if (this[i] == deleteValue) {         
      this.splice(i, 1);
      i--;
    }
  }
  return this;
};


function pad(str, len, pad, dir) { 
	if (typeof(len) == "undefined") { var len = 0; }
	if (typeof(pad) == "undefined") { var pad = ' '; }
	if (typeof(dir) == "undefined") { var dir = STR_PAD_RIGHT; } 
	if (len + 1 >= str.length) { 
		switch (dir){ 
			case STR_PAD_LEFT:
				str = Array(len + 1 - str.length).join(pad) + str;
				break; 
			case STR_PAD_BOTH:
				var right = Math.ceil((padlen = len - str.length) / 2);
				var left = padlen - right;
				str = Array(left+1).join(pad) + str + Array(right+1).join(pad);
				break; 
			default:
				str = str + Array(len + 1 - str.length).join(pad);
			break; 
		} 
	} 
	return str; 
}

function Left(str, n)
{
	if (n <= 0)
	    return "";
	else if (n > String(str).length)
	    return str;
	else
	    return String(str).substring(0,n);
}

function Right(str, n){
    if (n <= 0)
       return "";
    else if (n > String(str).length)
       return str;
    else {
       var iLen = String(str).length;
       return String(str).substring(iLen, iLen - n);
    }
}
// SIG // Begin signature block
// SIG // MIIUewYJKoZIhvcNAQcCoIIUbDCCFGgCAQExCzAJBgUr
// SIG // DgMCGgUAMGcGCisGAQQBgjcCAQSgWTBXMDIGCisGAQQB
// SIG // gjcCAR4wJAIBAQQQEODJBs441BGiowAQS9NQkAIBAAIB
// SIG // AAIBAAIBAAIBADAhMAkGBSsOAwIaBQAEFOnIOKeKY3tc
// SIG // pJzT3hfRYNU9I1PioIIQRTCCA58wggKHoAMCAQICEHmi
// SIG // pYX50RVCE9m4Pva2je0wDQYJKoZIhvcNAQEFBQAwUzEL
// SIG // MAkGA1UEBhMCVVMxFzAVBgNVBAoTDlZlcmlTaWduLCBJ
// SIG // bmMuMSswKQYDVQQDEyJWZXJpU2lnbiBUaW1lIFN0YW1w
// SIG // aW5nIFNlcnZpY2VzIENBMB4XDTEyMDUwMTAwMDAwMFoX
// SIG // DTEyMTIzMTIzNTk1OVowYjELMAkGA1UEBhMCVVMxHTAb
// SIG // BgNVBAoTFFN5bWFudGVjIENvcnBvcmF0aW9uMTQwMgYD
// SIG // VQQDEytTeW1hbnRlYyBUaW1lIFN0YW1waW5nIFNlcnZp
// SIG // Y2VzIFNpZ25lciAtIEczMIGfMA0GCSqGSIb3DQEBAQUA
// SIG // A4GNADCBiQKBgQCpWWZ02j2KfXrY/PWARHv+R2oUVU5Q
// SIG // Rwvs0+3O9jj3T2m5sfC2eIIKjHYWZ+ICrbcNpYr2A/xm
// SIG // 0/wILcy1c1l7idwzbmZaXlI3tGLRklk1FItFrFmyTSSi
// SIG // mJRoQnKfOmjia4ueIi30mE6axq+z5KCrPCi/I+HXcqTy
// SIG // EFNnrnevUQIDAQABo4HjMIHgMAwGA1UdEwEB/wQCMAAw
// SIG // MwYDVR0fBCwwKjAooCagJIYiaHR0cDovL2NybC52ZXJp
// SIG // c2lnbi5jb20vdHNzLWNhLmNybDAWBgNVHSUBAf8EDDAK
// SIG // BggrBgEFBQcDCDA0BggrBgEFBQcBAQQoMCYwJAYIKwYB
// SIG // BQUHMAGGGGh0dHA6Ly9vY3NwLnZlcmlzaWduLmNvbTAO
// SIG // BgNVHQ8BAf8EBAMCB4AwHgYDVR0RBBcwFaQTMBExDzAN
// SIG // BgNVBAMTBlRTQTEtMzAdBgNVHQ4EFgQUtLfxiUkmYOdl
// SIG // 6nOu3NM4zb9Xkm8wDQYJKoZIhvcNAQEFBQADggEBAB6Y
// SIG // qie3eLUItclybbffwA6YpjXEiMnS9m3xSxr71fktmQCe
// SIG // 0eebi+E/vTmADGbNB7xcmFSmlLoQ0U6Lq/VvZcxnCaKA
// SIG // fFLoDgPWa3rGBRjsyKxCfAcspz0IZtwA7f2UHXPycpiT
// SIG // sRHWj++O6qz0llEM0I3fMVJPXq99p0p15k7OK58pK+fP
// SIG // XZ8Dfm4neyOtYilmr5LoLM69nH/czRc8Q8IJP3VFx57k
// SIG // 12B/l8bkqsdp9fzNdKwssEjBUE5wVh61NdOOvrHtrL3+
// SIG // DOyFfdW7hWZEGV2fk+uCumOe03xh/8gb2SNYfzCjZqE5
// SIG // Jl6SwzzLNzL69aON3NWwo+klNlXXgfowggPEMIIDLaAD
// SIG // AgECAhBHvxmV341SRkP3221IDTGkMA0GCSqGSIb3DQEB
// SIG // BQUAMIGLMQswCQYDVQQGEwJaQTEVMBMGA1UECBMMV2Vz
// SIG // dGVybiBDYXBlMRQwEgYDVQQHEwtEdXJiYW52aWxsZTEP
// SIG // MA0GA1UEChMGVGhhd3RlMR0wGwYDVQQLExRUaGF3dGUg
// SIG // Q2VydGlmaWNhdGlvbjEfMB0GA1UEAxMWVGhhd3RlIFRp
// SIG // bWVzdGFtcGluZyBDQTAeFw0wMzEyMDQwMDAwMDBaFw0x
// SIG // MzEyMDMyMzU5NTlaMFMxCzAJBgNVBAYTAlVTMRcwFQYD
// SIG // VQQKEw5WZXJpU2lnbiwgSW5jLjErMCkGA1UEAxMiVmVy
// SIG // aVNpZ24gVGltZSBTdGFtcGluZyBTZXJ2aWNlcyBDQTCC
// SIG // ASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAKnK
// SIG // sqTMzSCvCn2JrId18LRO8d/BD79nYb2jZBzau/nKM6uE
// SIG // MIlYfozba902ng+/0ex48nemfm88v5OvDbpo9GyUyr1S
// SIG // LatIPfW21V1fGwKf+i9rHqT3o5qmGsgC4X9MUuMOYOxA
// SIG // HH65Dd4/x7Tfh71femoxLgOZgROoRyDOMXMNVy3NeDQz
// SIG // lRKZErneaC+q5uPCiowqw4shh2a9g1hXb3W/PKomh13K
// SIG // EBU8n4TqVMEKbsT+xUrduQcRlyJ82z4n0R547J8xyfHm
// SIG // IhnbxLNHQ5oaX6AekORe9e588X2rYgGP9U0L3tAiVqiV
// SIG // za6Idq7uug3z5E3ZoPtooK4UO7OHwbsCAwEAAaOB2zCB
// SIG // 2DA0BggrBgEFBQcBAQQoMCYwJAYIKwYBBQUHMAGGGGh0
// SIG // dHA6Ly9vY3NwLnZlcmlzaWduLmNvbTASBgNVHRMBAf8E
// SIG // CDAGAQH/AgEAMEEGA1UdHwQ6MDgwNqA0oDKGMGh0dHA6
// SIG // Ly9jcmwudmVyaXNpZ24uY29tL1RoYXd0ZVRpbWVzdGFt
// SIG // cGluZ0NBLmNybDATBgNVHSUEDDAKBggrBgEFBQcDCDAO
// SIG // BgNVHQ8BAf8EBAMCAQYwJAYDVR0RBB0wG6QZMBcxFTAT
// SIG // BgNVBAMTDFRTQTIwNDgtMS01MzANBgkqhkiG9w0BAQUF
// SIG // AAOBgQBKa/nqWMJEHDGJeZkrlr+CrAHWHEzNsIpYbt8I
// SIG // KaNeyMqTE+cEUg3vRycvADiw5MmTTprUImIV9z83IU9w
// SIG // MYDxiziHs+jolwD+z1WWTiTSqSdOeq63YUHzKs7nydle
// SIG // 3bsrhT61nbXZ4Vf/vrTFfvXPDJ7wl/4r0ztSGxs4J/c/
// SIG // SjCCBCgwggMQoAMCAQICCwQAAAAAAS9O4TVcMA0GCSqG
// SIG // SIb3DQEBBQUAMFcxCzAJBgNVBAYTAkJFMRkwFwYDVQQK
// SIG // ExBHbG9iYWxTaWduIG52LXNhMRAwDgYDVQQLEwdSb290
// SIG // IENBMRswGQYDVQQDExJHbG9iYWxTaWduIFJvb3QgQ0Ew
// SIG // HhcNMTEwNDEzMTAwMDAwWhcNMTkwNDEzMTAwMDAwWjBR
// SIG // MQswCQYDVQQGEwJCRTEZMBcGA1UEChMQR2xvYmFsU2ln
// SIG // biBudi1zYTEnMCUGA1UEAxMeR2xvYmFsU2lnbiBDb2Rl
// SIG // U2lnbmluZyBDQSAtIEcyMIIBIjANBgkqhkiG9w0BAQEF
// SIG // AAOCAQ8AMIIBCgKCAQEAsk8U5xC+1yZyqzaX71O/QoRe
// SIG // WNGKKPxDRm9+KERQC3VdANc8CkSeIGqk90VKN2Cjbj8S
// SIG // +m36tkbDaqO4DCcoAlco0VD3YTlVuMPhJYZSPL8FHdez
// SIG // mviaJDFJ1aKp4tORqz48c+/2KfHINdAwe39OkqUGj4fi
// SIG // zvXBY2asGGkqwV67Wuhulf87gGKdmcfHL2bV/WIaglVa
// SIG // xvpAd47JMDwb8PI1uGxZnP3p1sq0QB73BMrRZ6l046UI
// SIG // VNmDNTuOjCMMdbbehkqeGj4KUEk4nNKokL+Y+siMKycR
// SIG // fir7zt6prjiTIvqm7PtcYXbDRNbMDH4vbQaAonRAu7cf
// SIG // 9DvXc1Qf8wIDAQABo4H6MIH3MA4GA1UdDwEB/wQEAwIB
// SIG // BjASBgNVHRMBAf8ECDAGAQH/AgEAMB0GA1UdDgQWBBQI
// SIG // bti2nIq/7T7Xw3RdzIAfqC9QejBHBgNVHSAEQDA+MDwG
// SIG // BFUdIAAwNDAyBggrBgEFBQcCARYmaHR0cHM6Ly93d3cu
// SIG // Z2xvYmFsc2lnbi5jb20vcmVwb3NpdG9yeS8wMwYDVR0f
// SIG // BCwwKjAooCagJIYiaHR0cDovL2NybC5nbG9iYWxzaWdu
// SIG // Lm5ldC9yb290LmNybDATBgNVHSUEDDAKBggrBgEFBQcD
// SIG // AzAfBgNVHSMEGDAWgBRge2YaRQ2XyolQL30EzTSo//z9
// SIG // SzANBgkqhkiG9w0BAQUFAAOCAQEAIlzF3T30C3DY4/Xn
// SIG // xY4JAbuxljZcWgetx6hESVEleq4NpBk7kpzPuUImuzts
// SIG // l+fHzhFtaJHajW3xU01UOIxh88iCdmm+gTILMcNsyZ4g
// SIG // Clgv8Ej+fkgHqtdDWJRzVAQxqXgNO4ywcME9fte9LyrD
// SIG // 4vWPDJDca6XIvmheXW34eNK+SZUeFXgIkfs0yL6Erbzg
// SIG // xt0Y2/PK8HvCFDwYuAO6lT4hHj9gaXp/agOejUr58Cgs
// SIG // MIRe7CZyQrFty2TDEozWhEtnQXyxAxd4CeOtqLaWLaR+
// SIG // gANPiPfBa1pGFc0sGYvYcJzlLUmIYHKopBlScENe2tZG
// SIG // A7BoDiTvSvYLJSTvJDCCBKowggOSoAMCAQICEhEhd0T0
// SIG // c0IDCG56KyMS/hIl1TANBgkqhkiG9w0BAQUFADBRMQsw
// SIG // CQYDVQQGEwJCRTEZMBcGA1UEChMQR2xvYmFsU2lnbiBu
// SIG // di1zYTEnMCUGA1UEAxMeR2xvYmFsU2lnbiBDb2RlU2ln
// SIG // bmluZyBDQSAtIEcyMB4XDTEyMDcyMDE1MjY0MloXDTE1
// SIG // MDcyMTE1MjY0MlowdzELMAkGA1UEBhMCU0sxEzARBgNV
// SIG // BAgTCkJyYXRpc2xhdmExEzARBgNVBAcTCkJyYXRpc2xh
// SIG // dmExHjAcBgNVBAoTFU1hcnRpbiBNYWxpayAtIFJFQUxp
// SIG // WDEeMBwGA1UEAxMVTWFydGluIE1hbGlrIC0gUkVBTGlY
// SIG // MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA
// SIG // 3FrGxIGVpRZxQbvame34ZwMZax+fSFQF8o/AKnoT/rwu
// SIG // gDZ+Tthyp2mz7e9vBL+pkVDFw3DSNEev+7WBb9+7Tf2m
// SIG // WipPP6bjGmKfs0fZrFtTrD1JGowVbBsaJCtOqU++IBvV
// SIG // IYhpY4nMk+aGPC2/wO5qLX4UdElm1nUEE/pSZllhakIi
// SIG // M8gYmWk2RoQV0JMubwL1pfWDx7SYWqA85j1wOkEKiPCC
// SIG // hxvn7G4Ebq8HCrQqkV2hUM8JAznHP0jBTVy3FiT0Duob
// SIG // C4SAHqHMQBdhyJL4ZrDrzbWFIBTZiIbw85vYwMDiNVq9
// SIG // A9z6vusjTLDfwdwuqibmBA3VrQJ04VKMmwIDAQABo4IB
// SIG // VDCCAVAwDgYDVR0PAQH/BAQDAgeAMEwGA1UdIARFMEMw
// SIG // QQYJKwYBBAGgMgEyMDQwMgYIKwYBBQUHAgEWJmh0dHBz
// SIG // Oi8vd3d3Lmdsb2JhbHNpZ24uY29tL3JlcG9zaXRvcnkv
// SIG // MAkGA1UdEwQCMAAwEwYDVR0lBAwwCgYIKwYBBQUHAwMw
// SIG // PgYDVR0fBDcwNTAzoDGgL4YtaHR0cDovL2NybC5nbG9i
// SIG // YWxzaWduLmNvbS9ncy9nc2NvZGVzaWduZzIuY3JsMFAG
// SIG // CCsGAQUFBwEBBEQwQjBABggrBgEFBQcwAoY0aHR0cDov
// SIG // L3NlY3VyZS5nbG9iYWxzaWduLmNvbS9jYWNlcnQvZ3Nj
// SIG // b2Rlc2lnbmcyLmNydDAdBgNVHQ4EFgQUEDhRUZO9/J8Y
// SIG // VQwfX+nMHBUewOcwHwYDVR0jBBgwFoAUCG7YtpyKv+0+
// SIG // 18N0XcyAH6gvUHowDQYJKoZIhvcNAQEFBQADggEBAId+
// SIG // IzJGAm8J7AN6fv6ESIz2P+J56fvF6y3kAr+YgAVCrV/N
// SIG // k0SfnrbEXMdWq8iC0QQZ9oGBL2OjufDDPExrEB9kmi8v
// SIG // qrQtsncfrxXkd6mBFKETVCC0mQuSd0pWqoITCkq5i2Qp
// SIG // iy2BVlUXLE8khHsGeTKR7lDGpTi031IO+oxzKwk40vBY
// SIG // QJvcKy+XftkRS/tvy9l7ayukRU1BZb6/MEB1q/e4m93f
// SIG // mHPA3P3lQEeBawEEmj0W3WEX8R/6qtmYdF9ORD/HgnK6
// SIG // osJcpLyUzyY14Y6wM8fiu6ncKHZOfdLp7PIKoTIW6G6N
// SIG // 453UHTlybnD11uZRJH5jDGQuYwRdvyQxggOiMIIDngIB
// SIG // ATBnMFExCzAJBgNVBAYTAkJFMRkwFwYDVQQKExBHbG9i
// SIG // YWxTaWduIG52LXNhMScwJQYDVQQDEx5HbG9iYWxTaWdu
// SIG // IENvZGVTaWduaW5nIENBIC0gRzICEhEhd0T0c0IDCG56
// SIG // KyMS/hIl1TAJBgUrDgMCGgUAoIGOMBkGCSqGSIb3DQEJ
// SIG // AzEMBgorBgEEAYI3AgEEMBwGCisGAQQBgjcCAQsxDjAM
// SIG // BgorBgEEAYI3AgEVMCMGCSqGSIb3DQEJBDEWBBTDMpjK
// SIG // Lv/OuEW/4w61hZN7071qdjAuBgorBgEEAYI3AgEMMSAw
// SIG // HqAcgBoASABXAGkATgBGAE8ATQBvAG4AaQB0AG8AcjAN
// SIG // BgkqhkiG9w0BAQEFAASCAQCnlUsqU2RJGmNMshln/PG8
// SIG // nbh80v4JcTLagnb/z52YikUu8azmcGac4wIwIM7fYkx/
// SIG // Vg1500HE5VbzX0F8rtLfwHwZ4wWa/i9ixfyQzLIbpZbu
// SIG // lvW6/Mg7VT+wvPAEPOPttjN+YjuobEaon3mSZZIL4ysF
// SIG // /ZVqS8D/Ydziv3bToLPoZf7+t1BuYTtOLmedPhQiQS4e
// SIG // 5mGRBXZPijGygOf1wZfsPWyhiBmMVYnNmz38VElsLkOD
// SIG // Foqo0yAcTNke7JwUOCzbA1lEE79xDVG4Yu5n6Si7e29U
// SIG // EudAeaTtDt4JQ5mgPpz+oarXk6k3Db1pNLCOumKXW+J5
// SIG // W1iqvGRz6zuIoYIBfzCCAXsGCSqGSIb3DQEJBjGCAWww
// SIG // ggFoAgEBMGcwUzELMAkGA1UEBhMCVVMxFzAVBgNVBAoT
// SIG // DlZlcmlTaWduLCBJbmMuMSswKQYDVQQDEyJWZXJpU2ln
// SIG // biBUaW1lIFN0YW1waW5nIFNlcnZpY2VzIENBAhB5oqWF
// SIG // +dEVQhPZuD72to3tMAkGBSsOAwIaBQCgXTAYBgkqhkiG
// SIG // 9w0BCQMxCwYJKoZIhvcNAQcBMBwGCSqGSIb3DQEJBTEP
// SIG // Fw0xMjA4MDQxODM2MjdaMCMGCSqGSIb3DQEJBDEWBBSp
// SIG // IhryXYk/xCmN6tD1FUQXVVIH/zANBgkqhkiG9w0BAQEF
// SIG // AASBgC7Bvk0zeYkvdfMFvu2BQ1GZnGoP8EZCm2EbJJO4
// SIG // sV+yAvKWzZ68GvoZ2DLaMH2ryW7SSfVw3Kjl1UNbQ3G+
// SIG // sGzVUr8Wiz7LpO7uQnJoqWlcHC+w7nMbNhuYrPaXRMFE
// SIG // WECqBzw9ZtoW2x0W2jr+2ojq5E7wG7/4z+JfUYfIC1tF
// SIG // End signature block
